<?php 
    namespace EpidemicPageCounter;
	define('COPYRIGHT','http://logicraft.jis.click/?l1');
    
	date_default_timezone_set('Asia/Tokyo');
	function exchange_char(){
	// *********************************************************************
	// -- 説明 --
	// 文字列内のメタ文字をエスケープ文字に変換する。複数の引数を使って複合処理が可能。
	// -- バージョン --
	// v1.01
	// -- 動作環境 --
	// PHP 4.1.0以降
	// -- 引数 --
	// $args(0)		変換する文字列
	// $args(0以外)  ステータス -> HTML CSV REVERSE 等
	// -- デフォルト --
	// エンコード：UTF-8
	// -- 引数の値ごとの処理 --
	// HTML = HTMLメタ文字をエスケープ文字に変換 < > " ' &
	// CSV = CSVメタ文字をエスケープ文字に変換 , 改行コード
	// XML = 半角&を全角＆に変換
	// BR = 改行コードを<br>に変換
	// REVERSE = 指定した全てのエスケープ文字をメタ文字に変換
	// EUCJP = エンコードをEUCJPにする（引数にHTMLを入れているときのみ有効）
	// SJIS = エンコードをSJISにする（引数にHTMLを入れているときのみ有効）
	// UTF-8 = エンコードをUTF-8にする（引数にHTMLを入れているときのみ有効）
	// URL =
	//
	// -- 更新履歴 --
	// 2014.6.24 制作 LOGICRAFT T.Y
	// 2014.6.27 更新 LOGICRAFT T.Y ... 引数BRを追加
	//
	// *********************************************************************
		$args=func_get_args();
		
		$encode="UTF-8";
		
		$flag_html=false;
		$flag_csv=false;
		$flag_BR=false;
		$flag_XML=false;
		$flag_rXML=false;//あとにまわす処理フラグ
		$flag_REVERSE=false;
		$string=false;
		$cnt=0;
		foreach($args as $value){
			if($cnt==0){
				$string=$value;
			}else{
				if($value=='HTML'){
					$flag_html=true;
				}
				if($value=='CSV'){
					$flag_csv=true;
				}
				if($value=='XML'){
					$flag_XML=true;
				}
				if($value=='BR'){
					$flag_BR=true;
				}
				if($value=='REVERSE'){
					$flag_REVERSE=true;
				}
				if($value=='EUCJP'){
					$encode="EUC-JP";
				}
				if($value=='SJIS'){
					$encode="Shift_JIS";
				}
				if($value=='UTF-8'){
					$encode="UTF-8";
				}
			}
			$cnt++;
		}
		if(($flag_XML==true)&&($flag_REVERSE==true)){
			$flag_rXML=true;
		}elseif($flag_XML==true){
			$string=str_replace('&','＆',$string);
		}
		if(($flag_html==true)&&($flag_REVERSE==true)){
			$string=htmlspecialchars_decode($string,ENT_QUOTES);
		}elseif($flag_html==true){
			$string=htmlspecialchars($string,ENT_QUOTES,$encode);
			$string=str_replace('&amp;','&',$string);
		}
		if(($flag_csv==true)&&($flag_REVERSE==true)){
			$string=str_replace('&#44;',',',$string);
			$string=str_replace("<br>","\n",$string);
		}elseif($flag_csv==true){
			$string=str_replace(',','&#44;',$string);
			$string=str_replace("\r\n","<br>",$string);
			$string=str_replace("\r","<br>",$string);
			$string=str_replace("\n","<br>",$string);
		}
		if(($flag_BR==true)&&($flag_REVERSE==true)){
			$string=str_replace("<br>","\n",$string);
		}elseif($flag_BR==true){
			$string=str_replace("\r\n","<br>",$string);
			$string=str_replace("\r","<br>",$string);
			$string=str_replace("\n","<br>",$string);
		}
		// あとにまわした処理の解決
		if($flag_rXML==true){
			$string=str_replace('＆','&',$string);
		}
		// 値を返す
		return $string;
	}
	function arrayGetCsv($filename,$column=false){
	/*-------------------------------------------------------------------
	-- 機能 --
	二次元配列データをCSVファイルから読み込む。
	 保存時に排他処理を行う。
	 デリミタ、エンクロージャを含む文字列をエスケープする。
	 =二次元配列の内容例=
	 $data = array(array( "1", "hoge", "hogegege..." ),
				   array( "2", "fuga", "gugagaga..." ),
				   array( "3", "piyo", "piyoyoyo..." ));
	-- バージョン --
	v1.01
	-- 動作環境 --
	PHP 5
	-- 引数 --
	$filename		:読込先パス・ファイル名
	$column			:カラム数の指定
	-- 返り値 --
	読み込んだデータの二次元配列を返します。失敗した場合にfalseを返します。
	-- 更新履歴 --
	2014.11.28 制作 LOGICRAFT T.Y
    2015.04.17 更新 LOGICRAFT T.Y マルチバイト文字が消えるバグ対策の追加
	-------------------------------------------------------------------*/
		$filemode='r';
		$length=0;
		$delim=',';
		$enclosure='"';
		$ret=false;
		try{
            setlocale(LC_ALL, 'ja_JP.UTF-8');
			$fp=@fopen($filename,$filemode);
			if($fp){
				while(($buff=fgetcsv($fp,$length,$delim,$enclosure))!==false){
					if($column!==false){
						for($i=0;$i<=$column;$i++){
							if(!isset($buff[$i])){
								$buff[$i]=null;
							}
						}
					}
					$arraydata[]=$buff;
				}
				if(!empty($arraydata)){
					$ret=$arraydata;
				}
			}
		}catch(Exception $e){
			$ret=false;
		}
		return $ret;
	}
	function arrayPutCsv($filename,$arraydata){
	/*-------------------------------------------------------------------
	-- 機能 --
	二次元配列データをCSVファイルに保存する。
	 保存時に排他処理を行う。
	 デリミタ、エンクロージャを含む文字列をエスケープする。
	 =二次元配列の内容例=
	 $data = array(array( "1", "hoge", "hogegege..." ),
				   array( "2", "fuga", "gugagaga..." ),
				   array( "3", "piyo", "piyoyoyo..." ));
	-- バージョン --
	v1.00
	-- 動作環境 --
	PHP 5
	-- 引数 --
	$filename		:保存先パス・ファイル名
	$ArrayData		:保存するデータ（二次元配列） 一次元=row 二次元=column
	-- 返り値 --
	書き込んだ文字列の長さを返します。失敗した場合にfalseを返します。
	また$arraydataが空データの場合は、保存を行わずにfalseを返す。
	-- 更新履歴 --
	2014.11.28 制作 LOGICRAFT T.Y
	-------------------------------------------------------------------*/
		$filemode='w';
		$delim=',';
		$enclosure='"';
		$ret=false;
		if($arraydata!==null){
			$fp=@fopen($filename,$filemode);
			if($fp){
				if(flock($fp, LOCK_EX)){
					foreach($arraydata as $rowdata){
						$ret=@fputcsv($fp,$rowdata,$delim,$enclosure);
					}
					flock($fp,LOCK_UN);
				}		
				fclose($fp);
			}
		}
		return $ret;
	}
	function loadSetting(){
		/* -------------------------------
			column
			0	:	集計期間（日）
			1	:	パスワード
			2	:	ランキング表示数
			3	:	背景の色
			4	:	ラインの色
			5	:	文字の色
			6	:	文字のサイズ
			7	:	文字の最大表示数
			8	:	表の大きさ（幅）
			9	:	リンクの表示方法 0=タイトルのみ 1=画像あり
			10	:	自サイトのルートurl
			11	:	画像 横幅 x
			12	:	画像 縦幅 y
			13	:	最初から何番目の画像を表示
			14	:	CSSURL
            15  :   CSS添付 0=添付する 1=添付しない
		--------------------------------*/
		$settingData=false;
        $thisLocation=dirname(__FILE__).'/';
        $setting_csv=$thisLocation.'setting.csv';
		if(file_exists($setting_csv)){
			$settingData=arrayGetCsv($setting_csv,15);
		}else{
			$my_url=$_SERVER["HTTP_HOST"];
            if(isset($_SERVER['HTTPS']) && ($_SERVER['HTTPS'] == 'on'))
            {
                $my_url='https://'.$my_url;
            }else{
                $my_url='http://'.$my_url;
            }
            $my_cssurl=$my_url.dirname($_SERVER["REQUEST_URI"]).'/epidemicpagecounter.css';
            $my_url.='/';
			$settingData=array();
			$settingData[]=array(7,'1234',20,'#E0E0FF','#0000FF','#909090',14,50,468,0,$my_url,180,150,1,$my_cssurl,0);
		}
        if(!is_numeric($SettingData[0][0])){
            $SettingData[0][0]=7;
        }
        if(!is_numeric($SettingData[0][2])){
            $SettingData[0][2]=20;
        }
        if(!preg_match('/#[a-fA-F0-9]{6}/',$SettingData[0][3])){
            $SettingData[0][3]='#FFFFFF';
        }
        if(!preg_match('/#[a-fA-F0-9]{6}/',$SettingData[0][4])){
            $SettingData[0][4]='#000000';
        }
        if(!preg_match('/#[a-fA-F0-9]{6}/',$SettingData[0][5])){
            $SettingData[0][5]='#000000';
        }
        if(!is_numeric($SettingData[0][6])){
            $SettingData[0][6]=14;
        }
        if(!is_numeric($SettingData[0][7])){
            $SettingData[0][7]=50;
        }
        if(!is_numeric($SettingData[0][8])){
            $SettingData[0][8]=468;
        }
        if(($SettingData[0][9]!=0)&&($SettingData[0][9]!=1)){
            $SettingData[0][9]=0;
        }
        if(!is_numeric($SettingData[0][11])){
            $SettingData[0][11]=180;
        }
        if(!is_numeric($SettingData[0][12])){
            $SettingData[0][12]=150;
        }
        if(!is_numeric($SettingData[0][13])){
            $SettingData[0][13]=1;
        }
		return $settingData;
	}
	function pickString($subject, $startPattern, $endPattern){
	/*-------------------------------------------------------------------
	-- 機能 --
	文字列「$subject」から、最初に見つけたパターン「$startPattern」から最初に見つけたパターン「$endPattern」までの文字列を抽出する
	　=抽出例=
	 引数1：$startPattern=<a>
	 引数2：$endPattern=</a>
		<a> <!--ここから-->
            サンプル1
			<a>サンプル2</a> <!--ここまで-->
		</a>
   　　抽出結果:サンプル1<a>サンプル2
    -- バージョン --
	v1.00
	-- 動作環境 --
	PHP 5.3.0以降
	-- 引数 --
	$subject		:抽出先文字列
	$startPattern	:初めのパターン
	$endPattern		:植わりのパターン
	-- 更新履歴 --
	2014.12.16 制作
	-------------------------------------------------------------------*/
		$macthPattern='#'.$startPattern.'[\s\S]*#';
		$res=preg_match($macthPattern,$subject,$matches);
		if($res!=0){
            $startPattern_length=iconv_strlen($startPattern);
			$matchString=substr($matches[0],$startPattern_length);
			$matchString=strstr($matchString,$endPattern,true);
			return $matchString;
		}else{
			return false;
		}
	}
	function suckDataFormURL($url,$position=0,$priorityOG=true){
	/*-------------------------------------------------------------------
	-- 機能 --
	抽出先URLからタイトルと画像を抽出する。
    
	-- バージョン --
	v1.00
	-- 動作環境 --
	PHP 5.3.0以降
	-- 引数 --
	$url		:抽出先URL
	$position	:最初から何番目の画像を抽出するか 初期値=0
	$priorityOG	:meta情報property="og:"がある場合の優先フラグ true=優先する false=優先しない
	-- 返り値 --	
	抽出した情報を配列で返す。
	 $data = array('タイトル',
                   '画像URL');
                   
	-- 更新履歴 --
	2014.12.18 制作
	-------------------------------------------------------------------*/
        $title=false;
        $imageurl=false;
		$htmltext=@file_get_contents($url);
        if($htmltext){
            $htmltext=mb_convert_encoding($htmltext,"UTF-8","EUC-JP,SJIS,JIS,ASCII,UTF-8");
            // タイトルの抽出
            $suckflg=false;
            if($priorityOG==true){
                $startPattern='og:title"';
                $endPattern='>';
                $picktext=pickString($htmltext, $startPattern, $endPattern);
                if($picktext!=false){
                    if(preg_match('/"(.*)"/',$picktext,$match)){
                        $title=$match[1];
                        $suckflg=true;
                    }else{
                        if(preg_match("/'(.*)'/",$picktext,$match)){
                            $title=$match[1];
                            $suckflg=true;
                        }
                    }
                }else{
                    $startPattern="og:title'";
                    $picktext=pickString($htmltext, $startPattern, $endPattern);
                    if($picktext!=false){
                        if(preg_match("/'(.*)'/",$picktext,$match)){
                            $title=$match[1];
                            $suckflg=true;
                        }else{
                            if(preg_match('/"(.*)"/',$picktext,$match)){
                                $title=$match[1];
                                $suckflg=true;
                            }
                        }
                    }
                }
            }
            if($suckflg==false){
                if(preg_match('/<.*title.*>(.*?)<.*\/title.*>/i',$htmltext,$match)){
                    if(!empty($match[1])){
                        $title=$match[1];
                    }
                }
            }
            // 画像の抽出
            $suckflg=false;
            if($priorityOG==true){
                $startPattern='og:image';
                $endPattern='>';
                $picktext=pickString($htmltext, $startPattern, $endPattern);
                if($picktext!=false){
                    if(preg_match('/http[^\s]*\.(jpg|jpeg|gif|png|bmp)/',$picktext,$match)){
                        $imageurl=$match[0];
                        $suckflg=true;
                    }
                }
            
            }
            if($suckflg==false){
                if(preg_match_all('/http[^\s]*\.(jpg|jpeg|gif|png|bmp)/',$htmltext,$match)){
                    if(!empty($match[0][$position])){
                        $imageurl=$match[0][$position];
                    }
                }
            }
        }
        return array($title,$imageurl);
	}
	function getResizeValue($origin_width,$origin_height,$view_width,$view_heigh){
	/*-------------------------------------------------------------------
	-- 機能 --
	画像を指定サイズに収まるようにトリミングとリサイズをする値を返す。
	-- バージョン --
	v1.00
	-- 動作環境 --
	PHP 5
	-- 引数 --
	$origin_width	:画像の元サイズ 幅
	$origin_height	:画像の元サイズ 高さ
	$view_width		:指定サイズ 幅
	$view_heigh		:指定サイズ 高さ
	-- 返り値 --
	リサイズ+トリミング用の値を配列で返します。失敗した場合にfalseを返します。
	 =配列の内容=
	   $array('width',	リサイズした 幅
			  'height',	リサイズした 高さ
			  'left'	配置位置 左
			  'top')	配置位置 上
				  
	-- 更新履歴 --
	2014.12.03 制作 LOGICRAFT T.Y
	-------------------------------------------------------------------*/
		try{
			$origin_width=intval($origin_width);
			$origin_height=intval($origin_height);
			$view_width=intval($view_width);
			$view_heigh=intval($view_heigh);
			if($origin_width>0&&$origin_height>0&&$view_width>0&&$view_heigh>0){
				$basesizeRatio=$view_heigh/$view_width;
				$sizeRatio=$origin_height/$origin_width;
				if ($basesizeRatio <= $sizeRatio) {
					$resizeX=$view_width;
					$resizeY=$origin_height*($view_width/$origin_width);
				} else {
					$resizeY=$view_heigh;
					$resizeX=$origin_width*($view_heigh/$origin_height);
				}
				$ret['width']=round($resizeX);
				$ret['height']=round($resizeY);
				$ret['left']=(0-round(($resizeX-$view_width)/2));
				$ret['top']=(0-round(($resizeY-$view_heigh)/2));
				if($ret['width']<=0||$ret['height']<=0){
					$ret=false;
				}
			}else{
				$ret=false;
			}
		}catch(Exception $e){
			$ret=false;
		}
		return $ret;
	}
	function aggregateEpidemicPage(){
	/*-------------------------------------------------------------------
	-- 機能 --
	ページ閲覧数の集計を行い、集計結果の配列データとファイルを作成する。
	-- バージョン --
	v1.00
	-- 動作環境 --
	PHP 5
	-- 返り値 --
	集計結果を配列で返します。
	-- 更新履歴 --
	2014.12.18 制作 LOGICRAFT T.Y
	-------------------------------------------------------------------*/
        set_time_limit(0); // タイムアウトしない
        $thisLocation=dirname(__FILE__).'/';
        $filtering_list_csv=$thisLocation.'filteringlist.csv';
        $page_ranking_html=$thisLocation.'pageranking.html';
		// セッティングデータのロード
		$SettingData=loadSetting();
		// 集計開始
		$nowtime=time();
		for($i=0;$i<exchange_char($SettingData[0][0],"HTML");$i++){
			$filename=$thisLocation.date('Ymd',$nowtime-(86400*$i)).'.csv';
			if(file_exists($filename)){
				$buf=file_get_contents($filename);
				$load_data=explode("\n", $buf);
				foreach($load_data as $value){
					list($addr,$count)=explode(",",$value);
					$set_flag=false;
					if(is_array($displaydata)){
                        foreach($displaydata as &$a_value){
                            if($a_value[0]==$addr){
                                $a_value[1]=$a_value[1]+$count;
                                $set_flag=true;
                                break;
                            }
                        }
                        unset($a_value);
					}
					if($set_flag===false){
						$displaydata[]=array($addr,$count,'',$SettingData[0][10].trim($addr,'/'),'',0,0);
					}
				}
			}
		}
        // フィルタリング
		if(file_exists($filtering_list_csv)){
			/* -- $filtering_list_csv ----
			 column key
				0 :	url			サイトURL
				1 :	sitename	サイト名
				2:	replace		置換文字
				3:	filter		フィルタフラグ 1=表示しない
			--------------------------------*/
            if(is_array($displaydata)){
                $aggregate_data=$displaydata;
                unset($displaydata);
                $filteringData=arrayGetCsv($filtering_list_csv);
                foreach($filteringData as $f_value){
                    $delet_list=null;
                    $replace_flag=false;
                    $a_count=0;
                    if(!empty($f_value[2])){
                        foreach($aggregate_data as $a_key => $a_value){
                            if(strpos($a_value[0],$f_value[2])!==false){
                                $a_count=$a_count+$a_value[1];
                                $replace_flag=true;
                                $delet_list[]=$a_key;
                            }
                        }
                        if($replace_flag==true){
                            if($f_value[3]!=1){
                                $displaydata[]=array($f_value[1],$a_count,$f_value[2],$f_value[0],'',0,0);
                            }
                            if(is_array($delet_list)){
                                rsort($delet_list);
                                foreach($delet_list as $d_value){
                                    $del_array=array_splice($aggregate_data,$d_value,1);
                                }
                            }
                        }
                    }
                }
                foreach($aggregate_data as $a_value){
                    $displaydata[]=array($a_value[0],$a_value[1],$a_value[2],$a_value[3],'',0,0);
                }
                unset($aggregate_data);
            }
		}
		// 二次元配列の並び替え(複数要素）
		if(is_array($displaydata)){
			foreach($displaydata as $key => $sort_data_value){
				$sort_url[$key] = $sort_data_value[0];
				$sort_cnt[$key] = $sort_data_value[1];
			}
			array_multisort($sort_cnt,SORT_DESC,SORT_NUMERIC,$sort_url,SORT_ASC,SORT_STRING,$displaydata);
		}
        $s_charlength=$SettingData[0][7];
		// 人気ページランキング生成
        if($SettingData[0][9]!=1){
            $s_bgcolor=$SettingData[0][3];
            $s_linecolor=$SettingData[0][4];
            $s_charcolor=$SettingData[0][5];
            $s_charsize=$SettingData[0][6];
            $s_base_width=$SettingData[0][8];
            $s_width=$SettingData[0][8]-80;
            $s_influence=$SettingData[0][9];
            $html='<div style="width:'.$s_base_width.'px;overflow:hidden;">';
            $html.='<table border="1" style="border-collapse:collapse;border-spacing:0;word-wrap:break-word;background:'.$s_bgcolor.';border-color:'.$s_linecolor.';color:'.$s_charcolor.';font-size:'.$s_charsize.'px;">';
            $html.='<tr>';
            $html.='<td colspan="3" style="padding:1px;text-align:center;background:'.$s_linecolor.';color:'.$s_bgcolor.';">人気ページランキング</td>';
            $html.='</tr>';
            $ranking_no=0;
            if(is_array($displaydata)){
                foreach($displaydata as $value){
                    list($title,$value[4])=suckDataFormURL($value[3],$imgno);
                    if(empty($title)){
                        $title=$value[0];
                    }
                    $ranking_no++;
                    $html.='<tr>';
                    $html.='<td style="padding:1px;text-align:center;min-width:30px;max-width:30px;">'.$ranking_no.'</td>';
                    $html.='<td style="padding:1px;min-width:'.$s_width.'px; max-width:'.$s_width.'px;"><a href="'.$value[3].'" title="'.$title.'" alt="'.$title.'" target=”_blank” style="text-decoration:none;"><span style="color:'.$s_charcolor.';">'.mb_strimwidth($title,0,$s_charlength,'..','utf-8').'</span></a></td>';
                    $html.='<td style="padding:1px;text-align:center;min-width:40px;max-width:40px;">'.$value[1].'</td>';
                    $html.='</tr>';
                    if($ranking_no>=$SettingData[0][2]){
                        break;
                    }
                }
            }
            $html.='<tr>';
            $html.='<td colspan="3" style="padding:1px;text-align:center;"><a href="'.COPYRIGHT.'" target=”_blank” style="text-decoration:none;"><span style="color:#707070;">powered by LOGICRAFT</span></a></td>';
            $html.='</tr>';
            $html.='</table>';
            $html.='</div>';
        }else{
        // タイトルと画像の取得
            if(preg_match('/#[a-fA-F0-9]{6}/',$SettingData[0][3])){
                $origin_color['red']=hexdec(substr($SettingData[0][3],1,2));
                $origin_color['green']=hexdec(substr($SettingData[0][3],3,2));
                $origin_color['blue']=hexdec(substr($SettingData[0][3],5,2));
                $color='rgba('.$origin_color['red'].','.$origin_color['green'].','.$origin_color['blue'].',0.5)';
                foreach($origin_color as &$value){
                    $value=$value+83;
                    if($value>255){
                        $value=255;
                    }
                }
                $bg_color='rgba('.$origin_color['red'].','.$origin_color['green'].','.$origin_color['blue'].',0.5)';
            }else{
                $color='rgba(0,0,0,0,0.5)';
            }
            $box_width=$SettingData[0][11]-4;
            $box_height=$SettingData[0][12]-4;
            $html='';
            if($SettingData[0][15]!=1){
                $html.='<link href="'.$SettingData[0][14].'" rel="stylesheet" type="text/css">'."\n";
            }
            $html.='<div class="epidemicpagecounter_body">'."\n";
            $displayed_count=0;
            if(is_array($displaydata)){
                foreach($displaydata as &$a_value){
                    $imgno=$SettingData[0][13]-1;
                    if($imgno<0){
                        $imgno=0;
                    }
                    list($title,$a_value[4])=suckDataFormURL($a_value[3],$imgno);
                    $imginfo = @getimagesize($a_value[4]);
                    if(!empty($imginfo[0])){
                        $a_value[5]=$imginfo[0];
                    }
                    if(!empty($imginfo[1])){
                        $a_value[6]=$imginfo[1];
                    }
                    if(empty($title)){
                        $title=$a_value[0];
                    }
                    $img=$a_value[4];
                    $imgw=$a_value[5];
                    $imgh=$a_value[6];
                    if(!empty($a_value[3])){
                        $link=$a_value[3];
                        $b_link=$link;
                    }else{
                        $link=$url;
                        $b_link='';
                    }
                    $html.='  <div class="epidemicpagecounter_link_article">'."\n";
                    $html.='    <div class="img" style="background-color:'.$bg_color.';width:'.$box_width.'px; height:'.$box_height.'px;">'."\n";
                    if($imgvalue=getResizeValue($imgw,$imgh,$box_width,$box_height)){
                        $html.='      <a href="'.$link.'" title="'.$title.'"><img border="0" class="thumb" style="top:'.$imgvalue['top'].'px; left:'.$imgvalue['left'].'px;" src="'.$img.'" width="'.$imgvalue['width'].'" height="'.$imgvalue['height'].'" alt="'.$title.'"></a>'."\n";
                    }else{
                        $html.='      <a href="'.$link.'" title="'.$title.'"><div style="width:'.$box_width.'px; height:'.$box_height.'px;"></div></a>'."\n";
                    }
                    $html.='    </div>'."\n";
                    $html.='    <div class="other" style="background-color:'.$color.';min-width:'.$box_width.'px;">'."\n";
                    $html.='      <a class="title" href="'.$link.'" title="'.$title.'" alt="'.$title.'">'.mb_strimwidth($title,0,$s_charlength,'..','utf-8').'</a>'."\n";
                    $html.='    </div>'."\n";
                    $html.='  </div>'."\n";
                    $displayed_count++;
                    if($displayed_count>=$SettingData[0][2]){
                        break;
                    }
                }
            }
            $html.='  <div class="epidemicpagecounter_link_log" style="width:'.($box_width-4).'px;">'."\n";
            $html.='    <p><a href="'.COPYRIGHT.'" target=”_blank” style="text-decoration:none;"><span style="color:#707070;">powered by LOGICRAFT</span></a></p>'."\n";
            $html.='  </div>'."\n";
            $html.='</div>'."\n";
        }
		file_put_contents($page_ranking_html, $html, LOCK_EX);
		deleteAggregateFile();
		return $displaydata;
	}
	function deleteAggregateFile(){
	/*-------------------------------------------------------------------
	-- 機能 --
	100日以上前の集計ファイルを削除する。
	-- バージョン --
	v1.00
	-- 動作環境 --
	PHP 5
	-- 返り値 --
	成功した場合にtrueを返します。失敗した場合にfalseを返します。
	-- 更新履歴 --
	2014.12.01 制作 LOGICRAFT T.Y
	-------------------------------------------------------------------*/
		$retentionperiod=8640000;
        $thisLocation=dirname(__FILE__).'/';
		$ret=true;
		try{
			$deadline=time()-$retentionperiod;
			$csvfilelist=glob($thisLocation.'*.csv');
			foreach($csvfilelist as $value){
				if(preg_match('/[0-9]{8}/',$value,$matches)){
					$filedate=substr($matches[0],0,4).'-'.substr($matches[0],4,2).'-'.substr($matches[0],6,2).' 00:00:00';
					$timestamp=strtotime($filedate);
					if($deadline>=$timestamp){
						unlink($value);
					}
				}
			}
		}catch(Exception $e){
			$ret=false;
		}
		return $ret;
	}